## iproute2 4.20.0

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
# Top level Makefile for iproute2

ifeq ("$(origin V)", "command line")
VERBOSE = $(V)
endif
ifndef VERBOSE
VERBOSE = 0
endif

ifeq ($(VERBOSE),0)
MAKEFLAGS += --no-print-directory
endif

PREFIX?=/usr
LIBDIR?=$(PREFIX)/lib
SBINDIR?=/sbin
CONFDIR?=/etc/iproute2
NETNS_RUN_DIR?=/var/run/netns
NETNS_ETC_DIR?=/etc/netns
DATADIR?=$(PREFIX)/share
HDRDIR?=$(PREFIX)/include/iproute2
DOCDIR?=$(DATADIR)/doc/iproute2
MANDIR?=$(DATADIR)/man
ARPDDIR?=/var/lib/arpd
KERNEL_INCLUDE?=/usr/include
BASH_COMPDIR?=$(DATADIR)/bash-completion/completions

# Path to db_185.h include
DBM_INCLUDE:=$(DESTDIR)/usr/include

SHARED_LIBS = y

DEFINES= -DRESOLVE_HOSTNAMES -DLIBDIR=\"$(LIBDIR)\"
ifneq ($(SHARED_LIBS),y)
DEFINES+= -DNO_SHARED_LIBS
endif

DEFINES+=-DCONFDIR=\"$(CONFDIR)\" \
         -DNETNS_RUN_DIR=\"$(NETNS_RUN_DIR)\" \
         -DNETNS_ETC_DIR=\"$(NETNS_ETC_DIR)\"

#options for decnet
ADDLIB+=dnet_ntop.o dnet_pton.o

#options for ipx
ADDLIB+=ipx_ntop.o ipx_pton.o

#options for mpls
ADDLIB+=mpls_ntop.o mpls_pton.o

CC := gcc
HOSTCC ?= $(CC)
DEFINES += -D_GNU_SOURCE
# Turn on transparent support for LFS
DEFINES += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
CCOPTS = -O2
WFLAGS := -Wall -Wstrict-prototypes  -Wmissing-prototypes
WFLAGS += -Wmissing-declarations -Wold-style-definition -Wformat=2

CFLAGS := $(WFLAGS) $(CCOPTS) -I../include -I../include/uapi $(DEFINES) $(CFLAGS)
YACCFLAGS = -d -t -v

SUBDIRS=lib ip tc bridge misc netem genl tipc devlink rdma man

LIBNETLINK=../lib/libutil.a ../lib/libnetlink.a
LDLIBS += $(LIBNETLINK)

all: config.mk
	@set -e; \
	for i in $(SUBDIRS); \
	do echo; echo $$i; $(MAKE) $(MFLAGS) -C $$i; done

help:
	@echo "Make Targets:"
	@echo " all                 - build binaries"
	@echo " clean               - remove products of build"
	@echo " distclean           - remove configuration and build"
	@echo " install             - install binaries on local machine"
	@echo " check               - run tests"
	@echo " cscope              - build cscope database"
	@echo " snapshot            - generate version number header"
	@echo ""
	@echo "Make Arguments:"
	@echo " V=[0|1]             - set build verbosity level"

config.mk:
	sh configure $(KERNEL_INCLUDE)

install: all
	install -m 0755 -d $(DESTDIR)$(SBINDIR)
	install -m 0755 -d $(DESTDIR)$(CONFDIR)
	install -m 0755 -d $(DESTDIR)$(ARPDDIR)
	install -m 0755 -d $(DESTDIR)$(HDRDIR)
	install -m 0755 -d $(DESTDIR)$(DOCDIR)/examples
	install -m 0755 -d $(DESTDIR)$(DOCDIR)/examples/diffserv
	install -m 0644 README.iproute2+tc $(shell find examples -maxdepth 1 -type f) \
		$(DESTDIR)$(DOCDIR)/examples
	install -m 0644 $(shell find examples/diffserv -maxdepth 1 -type f) \
		$(DESTDIR)$(DOCDIR)/examples/diffserv
	@for i in $(SUBDIRS);  do $(MAKE) -C $$i install; done
	install -m 0644 $(shell find etc/iproute2 -maxdepth 1 -type f) $(DESTDIR)$(CONFDIR)
	install -m 0755 -d $(DESTDIR)$(BASH_COMPDIR)
	install -m 0644 bash-completion/tc $(DESTDIR)$(BASH_COMPDIR)
	install -m 0644 include/bpf_elf.h $(DESTDIR)$(HDRDIR)

snapshot:
	echo "static const char SNAPSHOT[] = \""`date +%y%m%d`"\";" \
		> include/SNAPSHOT.h

clean:
	@for i in $(SUBDIRS) testsuite; \
	do $(MAKE) $(MFLAGS) -C $$i clean; done

clobber:
	touch config.mk
	$(MAKE) $(MFLAGS) clean
	rm -f config.mk cscope.*

distclean: clobber

check: all
	cd testsuite && $(MAKE) && $(MAKE) alltests

cscope:
	cscope -b -q -R -Iinclude -sip -slib -smisc -snetem -stc

.EXPORT_ALL_VARIABLES:

=== misc/Makefile ===
# SPDX-License-Identifier: GPL-2.0
SSOBJ=ss.o ssfilter.o
LNSTATOBJ=lnstat.o lnstat_util.o

TARGETS=ss nstat ifstat rtacct lnstat

include ../config.mk

ifeq ($(HAVE_BERKELEY_DB),y)
	TARGETS += arpd
endif

all: $(TARGETS)

ss: $(SSOBJ)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

nstat: nstat.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o nstat nstat.c $(LDLIBS) -lm

ifstat: ifstat.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o ifstat ifstat.c $(LDLIBS) -lm

rtacct: rtacct.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o rtacct rtacct.c $(LDLIBS) -lm

arpd: arpd.c
	$(QUIET_CC)$(CC) $(CFLAGS) -I$(DBM_INCLUDE) $(CPPFLAGS) $(LDFLAGS) -o arpd arpd.c $(LDLIBS) -ldb

ssfilter.c: ssfilter.y
	$(QUIET_YACC)bison ssfilter.y -o ssfilter.c

lnstat: $(LNSTATOBJ)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	install -m 0755 $(TARGETS) $(DESTDIR)$(SBINDIR)
	ln -sf lnstat $(DESTDIR)$(SBINDIR)/rtstat
	ln -sf lnstat $(DESTDIR)$(SBINDIR)/ctstat

clean:
	rm -f *.o $(TARGETS) ssfilter.c

=== tipc/Makefile ===
# SPDX-License-Identifier: GPL-2.0
include ../config.mk

TARGETS :=

ifeq ($(HAVE_MNL),y)

TIPCOBJ=bearer.o \
    cmdl.o link.o \
    media.o misc.o \
    msg.o nametable.o \
    node.o socket.o \
    peer.o tipc.o

TARGETS += tipc

endif

all: $(TARGETS) $(LIBS)

tipc: $(TIPCOBJ)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	for i in $(TARGETS); \
	do install -m 0755 $$i $(DESTDIR)$(SBINDIR); \
	done

clean:
	rm -f $(TIPCOBJ) $(TARGETS)

=== man/man7/Makefile ===
# SPDX-License-Identifier: GPL-2.0
MAN7PAGES = $(wildcard *.7)

all:

distclean: clean

clean:

install:
	$(INSTALLDIR) $(DESTDIR)$(MANDIR)/man7
	$(INSTALLMAN) $(MAN7PAGES) $(DESTDIR)$(MANDIR)/man7

.PHONY: install clean distclean

=== man/man8/Makefile ===
# SPDX-License-Identifier: GPL-2.0
TARGETS = ip-address.8 ip-link.8 ip-route.8

MAN8PAGES = $(TARGETS) $(filter-out $(TARGETS),$(wildcard *.8))

all: $(TARGETS)

ip-address.8: ip-address.8.in
	sed "s|@SYSCONFDIR@|$(CONFDIR)|g" $< > $@

ip-link.8: ip-link.8.in
	sed "s|@SYSCONFDIR@|$(CONFDIR)|g" $< > $@

ip-route.8: ip-route.8.in
	sed "s|@SYSCONFDIR@|$(CONFDIR)|g" $< > $@

distclean: clean

clean:
	@rm -f $(TARGETS)

install:
	$(INSTALLDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALLMAN) $(MAN8PAGES) $(DESTDIR)$(MANDIR)/man8

.PHONY: install clean distclean

=== debian/changelog ===
iproute2 (4.20.0-2+deb10u1) buster; urgency=medium

  * Backport ip-route-print-route-type-in-JSON-output.patch. Fixes bug in
    json output, backported from upstream. (Closes: #961278)
  * Backport tc-mqprio-json-ify-output.patch. Fixes bug in json output,
    backported from upstream. (Closes: #972784)
  * Backport ip-netns-use-flock-when-setting-up-run-netns.patch. Fixes
    race condition that DOSes the system when using ip netns add at boot.
    (Closes: #949235)

 -- Luca Boccassi <bluca@debian.org>  Thu, 03 Dec 2020 18:42:49 +0000

iproute2 (4.20.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Luca Boccassi <bluca@debian.org>  Thu, 10 Jan 2019 20:04:14 +0000

iproute2 (4.20.0-1) experimental; urgency=medium

  * Merge tag 'upstream/4.20.0'
  * Drop patches merged upstream in v4.20.0.

 -- Luca Boccassi <bluca@debian.org>  Wed, 09 Jan 2019 15:31:15 +0000

iproute2 (4.19.0-2) unstable; urgency=medium

  * Simplify debian/rules, just use dh tools.
  * Set CBUILD_CFLAGS for dpkg-buildflags-missing
  * Add gitlab-ci.yml for Salsa's CI
  * Backport patches to let build use dpkg-buildpkg's CPPFLAGS.
  * Backport patches to fix testsuite cleanup.
    0008-Makefile-have-check-target-depend-on-all.patch
    0009-testsuite-declare-dependency-between-TESTS-and-gener.patch
    0010-testsuite-delete-dummy-interface-after-default-route-tes.patch
    0011-testsuite-remove-gre-kmods-if-the-test-loads-them.patch
  * autopkgtest: use built-in macro to install build-depends
  * autopkgtest: simplify test script by just running make check
  * autopkgtest: install kmod and sudo, needed by upstream tests
  * autopkgtest: remove breaks-testbed tag
  * Bump Standards-Version to 4.3.0, no changes.

 -- Luca Boccassi <bluca@debian.org>  Mon, 24 Dec 2018 15:29:30 +0100

iproute2 (4.19.0-1) experimental; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

  [ Luca Boccassi ]
  * Merge tag 'upstream/4.19.0'
  * Skip test suite at build time.
  * Bump Standards-Version to 4.2.1, no changes.

 -- Luca Boccassi <bluca@debian.org>  Fri, 26 Oct 2018 16:38:42 +0100

iproute2 (4.18.0-2) unstable; urgency=medium

  * Ship installed headers in the iproute2 package.
    At the moment this inludes a single iproute2/bpf_elf.h header.
    (Closes: #904122)
  * Add "terse" DEB_BUILD_OPTIONS as per policy 4.2.0.
    Build with make V=1 by default as the new policy requests.
  * Set Rules-Requires-Root: no.
  * Bump debhelper compat level to 10.
  * Bump Standards-Version to 4.2.0.

 -- Luca Boccassi <bluca@debian.org>  Tue, 28 Aug 2018 16:55:44 +0100

=== debian/control ===
Source: iproute2
Section: net
Priority: optional
Maintainer: Alexander Wirt <formorer@debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>
Homepage: https://wiki.linuxfoundation.org/networking/iproute2
Vcs-Browser: https://salsa.debian.org/debian/iproute2.git
Vcs-Git: https://salsa.debian.org/debian/iproute2.git
Standards-Version: 4.3.0
Rules-Requires-Root: no
Build-Depends: bison,
               debhelper (>= 10~),
               flex,
               iptables-dev,
               libatm1-dev,
               libcap-dev,
               libdb-dev,
               libelf-dev,
               libmnl-dev,
               libselinux1-dev,
               linux-libc-dev,
               pkg-config,
               po-debconf,
               zlib1g-dev,

Package: iproute2
Priority: important
Architecture: linux-any
Provides: arpd
Conflicts: arpd, iproute (<< 20130000-1)
Replaces: iproute
Depends: ${misc:Depends}, ${shlibs:Depends}, libcap2-bin,
Recommends: ${ipmods:Recommends}
Suggests: iproute2-doc
Multi-Arch: foreign
Description: networking and traffic control tools
 The iproute2 suite is a collection of utilities for networking and
 traffic control.
 .
 These tools communicate with the Linux kernel via the (rt)netlink
 interface, providing advanced features not available through the
 legacy net-tools commands 'ifconfig' and 'route'.

Package: iproute2-doc
Section: doc
Architecture: all
Conflicts: iproute-doc (<< 20130000-1)
Replaces: iproute-doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: networking and traffic control tools - documentation
 The iproute2 suite is a collection of utilities for networking and
 traffic control.
 .
 This package contains the documentation for iproute.

=== debian/rules ===
#!/usr/bin/make -f

# for DEB_* variables
include /usr/share/dpkg/default.mk

ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	export CC=$(DEB_HOST_GNU_TYPE)-gcc
	export HOSTCC=gcc
	export PKG_CONFIG=$(DEB_HOST_GNU_TYPE)-pkg-config
else
	# some tools are to be built with the host compiler and intentionally
	# ignore the *FLAGS, use them anyway in a non-cross build to make
	# dpkg-buildflags-missing happy
	export CBUILD_CFLAGS=$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
endif

ifneq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=0
else
export VERBOSE=1
endif

export KERNEL_INCLUDE=./include

%:
	dh $@

override_dh_clean:
	dh_clean
	make distclean

override_dh_shlibdeps:
	dh_shlibdeps -a -Xq_atm.so -Xm_xt.so -Xm_ipt.so
	dh_shlibdeps -a -- -pipmods -dRecommends -e debian/iproute2/usr/lib/tc/m_xt.so -e debian/iproute2/usr/lib/tc/q_atm.so -xlibc6

override_dh_auto_test:
	# upstream test suite needs root and leaves machine unclean, skip it

## iproute2 5.2.0

=== debian/changelog ===
iproute2 (5.2.0-1ubuntu2) eoan; urgency=medium

  * debian/patches/git-tunnel-creation.patch:
    - backport upstream change to fix a tunnel creation problem which is
      leading to a failure on the network-manager ci 

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 10 Oct 2019 11:50:20 +0200

iproute2 (5.2.0-1ubuntu1) eoan; urgency=medium

  * Merge with Debian testing. Remaining changes:
    - Add: Ubuntu Fan driver (V2/3/4) patches
      - d/p/1000-ubuntu-poc-fan-driver.patch
        Ubuntu FAN driver support V2 (LP 1439706)
      - d/p/1001-ubuntu-poc-fan-driver-v3.patch
        Ubuntu FAN driver support V3 (LP 1470091)
      - d/p/1002-ubuntu-poc-fan-driver-vxlan.patch
        Ubuntu FAN driver support VXLAN V4.
    - Drop: debian/patches/0001-Add-moo-feature.patch
  * Dropped changes:
    - d/p/1005-lib-suppress-error-msg-when-filling-the-cache.patch
      Already included upstream in 5.2.0.

 -- Stefan Bader <stefan.bader@canonical.com>  Thu, 08 Aug 2019 11:18:17 +0200

iproute2 (5.2.0-1) unstable; urgency=medium

  * Use /run/netns rather than /var/run/netns. Allows to manage namespaces
    early at boot in case /var is on a different filesystem. (Closes:
    #929774)
  * Update upstream source from tag 'upstream/5.2.0'
  * Refresh 0004-sync-iptables-header.patch, most of it has been merged
    upstream.

 -- Luca Boccassi <bluca@debian.org>  Tue, 09 Jul 2019 20:52:47 +0100

iproute2 (5.1.0-1ubuntu2) eoan; urgency=medium

  * Add: d/p/1005-lib-suppress-error-msg-when-filling-the-cache.patch
    Suppress meaningless error message during interface setup.

 -- Stefan Bader <stefan.bader@canonical.com>  Wed, 10 Jul 2019 16:38:52 +0200

iproute2 (5.1.0-1ubuntu1) eoan; urgency=medium

  * Merge with Debian experimental. Remaining changes:
    - Add: Ubuntu Fan driver (V2/3/4) patches
      - d/p/1000-ubuntu-poc-fan-driver.patch
        Ubuntu FAN driver support V2 (LP 1439706)
      - d/p/1001-ubuntu-poc-fan-driver-v3.patch
        Ubuntu FAN driver support V3 (LP 1470091)
      - d/p/1002-ubuntu-poc-fan-driver-vxlan.patch
        Ubuntu FAN driver support VXLAN V4.
    - Drop: debian/patches/0001-Add-moo-feature.patch
    - Refresh: Ubuntu Fan driver (V2/3/4) patches
  * Dropped changes:
    - d/p/1005-ubuntu-fix-testsuite-kenv.patch (upstream)
    - d/p/1006-ubuntu-iprule-fix-output.patch (upstream
    - d/p/ss-review-ssfilter.patch (upstream)
    - Set debhelper dependency to >= 10 (upstream)
    - Set compat level 10 (upstream)

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 17 Jun 2019 11:15:33 +0200

iproute2 (5.1.0-1) experimental; urgency=medium

  * Update upstream source from tag 'upstream/5.1.0'

 -- Luca Boccassi <bluca@debian.org>  Tue, 21 May 2019 15:43:15 +0100

iproute2 (5.0.0-1) experimental; urgency=medium

  * Update upstream source from tag 'upstream/5.0.0'
  * Add build flags check to Gitlab CI.
  * Build-depend on libbsd-dev, to avoid using internal strlcpy.
  * autopkgtest: build-depend on locales-all for manpage test

 -- Luca Boccassi <bluca@debian.org>  Thu, 21 Mar 2019 12:14:41 +0000

iproute2 (4.18.0-1ubuntu3) eoan; urgency=medium

  * d/p/ss-review-ssfilter.patch: fixed issue with ss and ssfilter
    where ssfilter rejects single expressions if enclosed in
    braces (LP: #1831775)

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Wed, 05 Jun 2019 21:26:00 -0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: iproute2
 Section: net
 Priority: optional
-Maintainer: Alexander Wirt <formorer@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Alexander Wirt <formorer@debian.org>
 Uploaders: Luca Boccassi <bluca@debian.org>
 Homepage: https://wiki.linuxfoundation.org/networking/iproute2
 Vcs-Browser: https://salsa.debian.org/debian/iproute2.git
@@ -13,6 +14,7 @@
                flex,
                iptables-dev,
                libatm1-dev,
+               libbsd-dev,
                libcap-dev,
                libdb-dev,
                libelf-dev,

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,7 @@
 endif
 
 export KERNEL_INCLUDE=./include
+export NETNS_RUN_DIR=/run/netns
 
 %:
 	dh $@

=== debian/tests/control ===
# the tests depend on the kernel and might break the env
# therefore do not run as build time tests
Tests: testsuite.sh
Restrictions: allow-stderr, isolation-machine, needs-root, rw-build-tree
Depends: build-essential, locales-all, dpkg-dev, sudo, kmod, @builddeps@

## iproute2 5.5.0

=== Makefile ===
--- 
+++ 
@@ -40,12 +40,6 @@
          -DNETNS_RUN_DIR=\"$(NETNS_RUN_DIR)\" \
          -DNETNS_ETC_DIR=\"$(NETNS_ETC_DIR)\"
 
-#options for decnet
-ADDLIB+=dnet_ntop.o dnet_pton.o
-
-#options for ipx
-ADDLIB+=ipx_ntop.o ipx_pton.o
-
 #options for mpls
 ADDLIB+=mpls_ntop.o mpls_pton.o
 
@@ -54,7 +48,7 @@
 DEFINES += -D_GNU_SOURCE
 # Turn on transparent support for LFS
 DEFINES += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
-CCOPTS = -O2
+CCOPTS = -O2 -pipe
 WFLAGS := -Wall -Wstrict-prototypes  -Wmissing-prototypes
 WFLAGS += -Wmissing-declarations -Wold-style-definition -Wformat=2
 
@@ -92,12 +86,6 @@
 	install -m 0755 -d $(DESTDIR)$(CONFDIR)
 	install -m 0755 -d $(DESTDIR)$(ARPDDIR)
 	install -m 0755 -d $(DESTDIR)$(HDRDIR)
-	install -m 0755 -d $(DESTDIR)$(DOCDIR)/examples
-	install -m 0755 -d $(DESTDIR)$(DOCDIR)/examples/diffserv
-	install -m 0644 README.iproute2+tc $(shell find examples -maxdepth 1 -type f) \
-		$(DESTDIR)$(DOCDIR)/examples
-	install -m 0644 $(shell find examples/diffserv -maxdepth 1 -type f) \
-		$(DESTDIR)$(DOCDIR)/examples/diffserv
 	@for i in $(SUBDIRS);  do $(MAKE) -C $$i install; done
 	install -m 0644 $(shell find etc/iproute2 -maxdepth 1 -type f) $(DESTDIR)$(CONFDIR)
 	install -m 0755 -d $(DESTDIR)$(BASH_COMPDIR)
@@ -120,7 +108,14 @@
 distclean: clobber
 
 check: all
-	cd testsuite && $(MAKE) && $(MAKE) alltests
+	$(MAKE) -C testsuite
+	$(MAKE) -C testsuite alltests
+	@if command -v man >/dev/null 2>&1; then \
+		echo "Checking manpages for syntax errors..."; \
+		$(MAKE) -C man check; \
+	else \
+		echo "man not installed, skipping checks for syntax errors."; \
+	fi
 
 cscope:
 	cscope -b -q -R -Iinclude -sip -slib -smisc -snetem -stc

=== ip/Makefile ===
# SPDX-License-Identifier: GPL-2.0
IPOBJ=ip.o ipaddress.o ipaddrlabel.o iproute.o iprule.o ipnetns.o \
    rtm_map.o iptunnel.o ip6tunnel.o tunnel.o ipneigh.o ipntable.o iplink.o \
    ipmaddr.o ipmonitor.o ipmroute.o ipprefix.o iptuntap.o iptoken.o \
    ipxfrm.o xfrm_state.o xfrm_policy.o xfrm_monitor.o iplink_dummy.o \
    iplink_ifb.o iplink_nlmon.o iplink_team.o iplink_vcan.o iplink_vxcan.o \
    iplink_vlan.o link_veth.o link_gre.o iplink_can.o iplink_xdp.o \
    iplink_macvlan.o ipl2tp.o link_vti.o link_vti6.o link_xfrm.o \
    iplink_vxlan.o tcp_metrics.o iplink_ipoib.o ipnetconf.o link_ip6tnl.o \
    link_iptnl.o link_gre6.o iplink_bond.o iplink_bond_slave.o iplink_hsr.o \
    iplink_bridge.o iplink_bridge_slave.o ipfou.o iplink_ipvlan.o \
    iplink_geneve.o iplink_vrf.o iproute_lwtunnel.o ipmacsec.o ipila.o \
    ipvrf.o iplink_xstats.o ipseg6.o iplink_netdevsim.o iplink_rmnet.o \
    ipnexthop.o

RTMONOBJ=rtmon.o

include ../config.mk

ALLOBJ=$(IPOBJ) $(RTMONOBJ)
SCRIPTS=ifcfg rtpr routel routef
TARGETS=ip rtmon

all: $(TARGETS) $(SCRIPTS)

ip: $(IPOBJ) $(LIBNETLINK)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

rtmon: $(RTMONOBJ)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	install -m 0755 $(TARGETS) $(DESTDIR)$(SBINDIR)
	install -m 0755 $(SCRIPTS) $(DESTDIR)$(SBINDIR)

clean:
	rm -f $(ALLOBJ) $(TARGETS)

SHARED_LIBS ?= y
ifeq ($(SHARED_LIBS),y)

LDLIBS += -ldl
LDFLAGS += -Wl,-export-dynamic

else

ip: static-syms.o
static-syms.o: static-syms.h
static-syms.h: $(wildcard *.c)
	files="$^" ; \
	for s in `grep -B 3 '\<dlsym' $$files | sed -n '/snprintf/{s:.*"\([^"]*\)".*:\1:;s:%s::;p}'` ; do \
		sed -n '/'$$s'[^ ]* =/{s:.* \([^ ]*'$$s'[^ ]*\) .*:extern char \1[] __attribute__((weak)); if (!strcmp(sym, "\1")) return \1;:;p}' $$files ; \
	done > $@

endif

=== misc/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # SPDX-License-Identifier: GPL-2.0
-SSOBJ=ss.o ssfilter.o
+SSOBJ=ss.o ssfilter.tab.o
 LNSTATOBJ=lnstat.o lnstat_util.o
 
 TARGETS=ss nstat ifstat rtacct lnstat
@@ -27,8 +27,8 @@
 arpd: arpd.c
 	$(QUIET_CC)$(CC) $(CFLAGS) -I$(DBM_INCLUDE) $(CPPFLAGS) $(LDFLAGS) -o arpd arpd.c $(LDLIBS) -ldb
 
-ssfilter.c: ssfilter.y
-	$(QUIET_YACC)bison ssfilter.y -o ssfilter.c
+ssfilter.tab.c: ssfilter.y
+	$(QUIET_YACC)$(YACC) -b ssfilter ssfilter.y
 
 lnstat: $(LNSTATOBJ)
 	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

=== rdma/Makefile ===
# SPDX-License-Identifier: GPL-2.0 OR Linux-OpenIB
include ../config.mk

TARGETS :=

ifeq ($(HAVE_MNL),y)
CFLAGS += -I./include/uapi/

RDMA_OBJ = rdma.o utils.o dev.o link.o res.o res-pd.o res-mr.o res-cq.o \
	   res-cmid.o res-qp.o sys.o stat.o stat-mr.o

TARGETS += rdma
endif

all:	$(TARGETS) $(LIBS)

rdma:	$(RDMA_OBJ) $(LIBS)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	for i in $(TARGETS); \
	do install -m 0755 $$i $(DESTDIR)$(SBINDIR); \
	done

clean:
	rm -f $(RDMA_OBJ) $(TARGETS)

=== man/man8/Makefile ===
--- 
+++ 
@@ -23,4 +23,8 @@
 	$(INSTALLDIR) $(DESTDIR)$(MANDIR)/man8
 	$(INSTALLMAN) $(MAN8PAGES) $(DESTDIR)$(MANDIR)/man8
 
-.PHONY: install clean distclean
+check: all
+	@for page in $(MAN8PAGES); do test 0 -eq $$($(MAN_CHECK) $$page \
+		$(MAN_REDIRECT)) || { echo "Error in $$page"; exit 1; }; done
+
+.PHONY: install clean distclean check

=== debian/changelog ===
iproute2 (5.5.0-1ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add: Ubuntu Fan driver (V2/3/4) patches
      - d/p/1000-ubuntu-poc-fan-driver.patch
        Ubuntu FAN driver support V2 (LP 1439706)
      - d/p/1001-ubuntu-poc-fan-driver-v3.patch
        Ubuntu FAN driver support V3 (LP 1470091)
      - d/p/1002-ubuntu-poc-fan-driver-vxlan.patch
        Ubuntu FAN driver support VXLAN V4.
    - Drop: debian/patches/0001-Add-moo-feature.patch
  * Dropped changes, included in Debian:
    - Make autopkgtests cross-test-friendly.
  * Dropped changes, included upstream:
    - debian/patches/git-tunnel-creation.patch:
      backport upstream change to fix a tunnel creation problem which is
      leading to a failure on the network-manager ci 

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 09:21:59 -0800

iproute2 (5.5.0-1) unstable; urgency=medium

  [ Steve Langasek ]
  * Make autopkgtests cross-test-friendly (Closes: #949566)

  [ Luca Boccassi ]
  * Bump Standards-Version to 4.5.0, no changes.
  * Build-depend on libxtables-dev instead of iptables-dev. (Closes:
    #951089)
  * Update upstream source from tag 'upstream/5.5.0'

 -- Luca Boccassi <bluca@debian.org>  Tue, 11 Feb 2020 10:51:46 +0000

iproute2 (5.4.0-1) unstable; urgency=medium

  * Fix Lintian Warning: spelling-error-in-changelog
  * Update upstream source from tag 'upstream/5.4.0'
  * iproute2-doc: upstream no longer ships examples

 -- Luca Boccassi <bluca@debian.org>  Thu, 28 Nov 2019 10:56:11 +0000

iproute2 (5.3.0-1) unstable; urgency=medium

  * Bump Standards-Version to 4.4.0, no changes.
  * Do not ship ifstat.8 manpage, as we do not ship the binary
  * Update upstream source from tag 'upstream/5.3.0'
  * Refresh patches for 5.3.0

 -- Luca Boccassi <bluca@debian.org>  Fri, 27 Sep 2019 12:17:59 +0100

iproute2 (5.2.0-1ubuntu3) focal; urgency=medium

  * Make autopkgtests cross-test-friendly.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 21 Jan 2020 16:22:08 -0800

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
 Homepage: https://wiki.linuxfoundation.org/networking/iproute2
 Vcs-Browser: https://salsa.debian.org/debian/iproute2.git
 Vcs-Git: https://salsa.debian.org/debian/iproute2.git
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Build-Depends: bison,
                debhelper (>= 10~),
                flex,
-               iptables-dev,
+               libxtables-dev,
                libatm1-dev,
                libbsd-dev,
                libcap-dev,

=== debian/rules ===
--- 
+++ 
@@ -36,3 +36,8 @@
 
 override_dh_auto_test:
 	# upstream test suite needs root and leaves machine unclean, skip it
+
+# We are not shipping the ifstat binary as it conflicts with another Debian
+# package, so avoid shipping the manpage as well. See #873818
+override_dh_install:
+	dh_install -Xifstat.8

## iproute2 5.7.0

=== debian/changelog ===
iproute2 (5.7.0-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add: Ubuntu Fan driver (V2/3/4) patches
      - d/p/1000-ubuntu-poc-fan-driver.patch
        Ubuntu FAN driver support V2 (LP 1439706)
      - d/p/1001-ubuntu-poc-fan-driver-v3.patch
        Ubuntu FAN driver support V3 (LP 1470091)
      - d/p/1002-ubuntu-poc-fan-driver-vxlan.patch
        Ubuntu FAN driver support VXLAN V4.
    - Drop: debian/patches/0001-Add-moo-feature.patch

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 09 Jun 2020 14:13:18 -0700

iproute2 (5.7.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.7.0'
  * Add override for Lintian false positive in iproute2-doc

 -- Luca Boccassi <bluca@debian.org>  Sat, 06 Jun 2020 12:27:27 +0100

iproute2 (5.6.0-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add: Ubuntu Fan driver (V2/3/4) patches
      - d/p/1000-ubuntu-poc-fan-driver.patch
        Ubuntu FAN driver support V2 (LP 1439706)
      - d/p/1001-ubuntu-poc-fan-driver-v3.patch
        Ubuntu FAN driver support V3 (LP 1470091)
      - d/p/1002-ubuntu-poc-fan-driver-vxlan.patch
        Ubuntu FAN driver support VXLAN V4.
    - Drop: debian/patches/0001-Add-moo-feature.patch

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 May 2020 15:23:39 -0700

iproute2 (5.6.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.6.0'
  * Set hardening=+all to enable BindNow
  * Use https in d/watch
  * Switch to debhelper-compat 12
  * Fix Vc-Browser field, remove .git
  * Minimize d/upstream/signing-key.asc
  * Add Lintian overrides for false positives

 -- Luca Boccassi <bluca@debian.org>  Fri, 03 Apr 2020 10:03:30 +0100

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 XSBC-Original-Maintainer: Alexander Wirt <formorer@debian.org>
 Uploaders: Luca Boccassi <bluca@debian.org>
 Homepage: https://wiki.linuxfoundation.org/networking/iproute2
-Vcs-Browser: https://salsa.debian.org/debian/iproute2.git
+Vcs-Browser: https://salsa.debian.org/debian/iproute2
 Vcs-Git: https://salsa.debian.org/debian/iproute2.git
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Build-Depends: bison,
-               debhelper (>= 10~),
+               debhelper-compat (= 12),
                flex,
                libxtables-dev,
                libatm1-dev,

## iproute2 5.9.0

=== debian/changelog ===
iproute2 (5.9.0-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add: Ubuntu Fan driver (V2/3/4) patches
      - d/p/1000-ubuntu-poc-fan-driver.patch
        Ubuntu FAN driver support V2 (LP 1439706)
      - d/p/1001-ubuntu-poc-fan-driver-v3.patch
        Ubuntu FAN driver support V3 (LP 1470091)
      - d/p/1002-ubuntu-poc-fan-driver-vxlan.patch
        Ubuntu FAN driver support VXLAN V4.
    - Drop: debian/patches/0001-Add-moo-feature.patch

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 24 Oct 2020 17:50:27 -0700

iproute2 (5.9.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.9.0'

 -- Luca Boccassi <bluca@debian.org>  Mon, 19 Oct 2020 10:49:53 +0100

iproute2 (5.8.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.8.0'
  * Refresh 0001-Add-moo-feature.patch to remove fuzz from 5.8.0

 -- Luca Boccassi <bluca@debian.org>  Wed, 12 Aug 2020 13:54:32 +0100

## iproute2 5.10.0

=== Makefile ===
--- 
+++ 
@@ -63,7 +63,9 @@
 all: config.mk
 	@set -e; \
 	for i in $(SUBDIRS); \
-	do echo; echo $$i; $(MAKE) $(MFLAGS) -C $$i; done
+	do echo; echo $$i; $(MAKE) -C $$i; done
+
+.PHONY: clean clobber distclean check cscope version
 
 help:
 	@echo "Make Targets:"
@@ -73,7 +75,7 @@
 	@echo " install             - install binaries on local machine"
 	@echo " check               - run tests"
 	@echo " cscope              - build cscope database"
-	@echo " snapshot            - generate version number header"
+	@echo " version             - update version"
 	@echo ""
 	@echo "Make Arguments:"
 	@echo " V=[0|1]             - set build verbosity level"
@@ -90,19 +92,20 @@
 	install -m 0644 $(shell find etc/iproute2 -maxdepth 1 -type f) $(DESTDIR)$(CONFDIR)
 	install -m 0755 -d $(DESTDIR)$(BASH_COMPDIR)
 	install -m 0644 bash-completion/tc $(DESTDIR)$(BASH_COMPDIR)
+	install -m 0644 bash-completion/devlink $(DESTDIR)$(BASH_COMPDIR)
 	install -m 0644 include/bpf_elf.h $(DESTDIR)$(HDRDIR)
 
-snapshot:
-	echo "static const char SNAPSHOT[] = \""`date +%y%m%d`"\";" \
-		> include/SNAPSHOT.h
+version:
+	echo "static const char version[] = \""`git describe --tags --long`"\";" \
+		> include/version.h
 
 clean:
 	@for i in $(SUBDIRS) testsuite; \
-	do $(MAKE) $(MFLAGS) -C $$i clean; done
+	do $(MAKE) -C $$i clean; done
 
 clobber:
 	touch config.mk
-	$(MAKE) $(MFLAGS) clean
+	$(MAKE) clean
 	rm -f config.mk cscope.*
 
 distclean: clobber

=== ip/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
     iplink_bridge.o iplink_bridge_slave.o ipfou.o iplink_ipvlan.o \
     iplink_geneve.o iplink_vrf.o iproute_lwtunnel.o ipmacsec.o ipila.o \
     ipvrf.o iplink_xstats.o ipseg6.o iplink_netdevsim.o iplink_rmnet.o \
-    ipnexthop.o
+    ipnexthop.o ipmptcp.o iplink_bareudp.o
 
 RTMONOBJ=rtmon.o

=== lib/Makefile ===
# SPDX-License-Identifier: GPL-2.0
include ../config.mk

CFLAGS += -fPIC

UTILOBJ = utils.o rt_names.o ll_map.o ll_types.o ll_proto.o ll_addr.o \
	inet_proto.o namespace.o json_writer.o json_print.o \
	names.o color.o bpf.o exec.o fs.o cg_map.o

NLOBJ=libgenl.o libnetlink.o

all: libnetlink.a libutil.a

libnetlink.a: $(NLOBJ)
	$(QUIET_AR)$(AR) rcs $@ $^

libutil.a: $(UTILOBJ) $(ADDLIB)
	$(QUIET_AR)$(AR) rcs $@ $^

install:

clean:
	rm -f $(NLOBJ) $(UTILOBJ) $(ADDLIB) libnetlink.a libutil.a

=== man/man8/Makefile ===
--- 
+++ 
@@ -1,18 +1,16 @@
 # SPDX-License-Identifier: GPL-2.0
-TARGETS = ip-address.8 ip-link.8 ip-route.8
+TARGETS = ip-address.8 ip-link.8 ip-netns.8 ip-route.8
 
 MAN8PAGES = $(TARGETS) $(filter-out $(TARGETS),$(wildcard *.8))
 
 all: $(TARGETS)
 
-ip-address.8: ip-address.8.in
-	sed "s|@SYSCONFDIR@|$(CONFDIR)|g" $< > $@
-
-ip-link.8: ip-link.8.in
-	sed "s|@SYSCONFDIR@|$(CONFDIR)|g" $< > $@
-
-ip-route.8: ip-route.8.in
-	sed "s|@SYSCONFDIR@|$(CONFDIR)|g" $< > $@
+%: %.in
+	sed \
+		-e "s|@NETNS_ETC_DIR@|$(NETNS_ETC_DIR)|g" \
+		-e "s|@NETNS_RUN_DIR@|$(NETNS_RUN_DIR)|g" \
+		-e "s|@SYSCONFDIR@|$(CONFDIR)|g" \
+		$< > $@
 
 distclean: clean

=== debian/changelog ===
iproute2 (5.10.0-4) unstable; urgency=medium

  * Backport 0012-iproute-force-rtm_dst_len-to-32-128.patch to fix ip
    route get with netmask (Closes: #944730)
  * Add d/not-installed file
  * Bump debhelper-compat to 13

 -- Luca Boccassi <bluca@debian.org>  Fri, 05 Feb 2021 23:34:59 +0000

iproute2 (5.10.0-3) unstable; urgency=medium

  * Backport patches to fix ip vrf exec (Closes: #980046)

 -- Luca Boccassi <bluca@debian.org>  Sun, 17 Jan 2021 23:11:31 +0000

iproute2 (5.10.0-2) unstable; urgency=medium

  * Backport patches from iproute2-next to support libbpf
  * Add build-dependency on libbpf-dev
  * Remove duplicated lines from iproute2.lintian-overridess

 -- Luca Boccassi <bluca@debian.org>  Sat, 26 Dec 2020 15:16:36 +0000

iproute2 (5.10.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.10.0'
    (Closes: #972784, #949235)
  * Bump Standards-Version to 4.5.1, no changes

 -- Luca Boccassi <bluca@debian.org>  Sun, 20 Dec 2020 22:47:37 +0000

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: iproute2
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alexander Wirt <formorer@debian.org>
+Maintainer: Alexander Wirt <formorer@debian.org>
 Uploaders: Luca Boccassi <bluca@debian.org>
 Homepage: https://wiki.linuxfoundation.org/networking/iproute2
 Vcs-Browser: https://salsa.debian.org/debian/iproute2
 Vcs-Git: https://salsa.debian.org/debian/iproute2.git
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Build-Depends: bison,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                flex,
                libxtables-dev,
                libatm1-dev,
                libbsd-dev,
+               libbpf-dev (>= 1:0.1.0~),
                libcap-dev,
                libdb-dev,
                libelf-dev,

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # for DEB_* variables
 include /usr/share/dpkg/default.mk

## iproute2 5.15.0

=== Makefile ===
--- 
+++ 
@@ -55,12 +55,12 @@
 CFLAGS := $(WFLAGS) $(CCOPTS) -I../include -I../include/uapi $(DEFINES) $(CFLAGS)
 YACCFLAGS = -d -t -v
 
-SUBDIRS=lib ip tc bridge misc netem genl tipc devlink rdma man
+SUBDIRS=lib ip tc bridge misc netem genl tipc devlink rdma dcb man vdpa
 
 LIBNETLINK=../lib/libutil.a ../lib/libnetlink.a
 LDLIBS += $(LIBNETLINK)
 
-all: config.mk
+all: config
 	@set -e; \
 	for i in $(SUBDIRS); \
 	do echo; echo $$i; $(MAKE) -C $$i; done
@@ -80,8 +80,10 @@
 	@echo "Make Arguments:"
 	@echo " V=[0|1]             - set build verbosity level"
 
-config.mk:
-	sh configure $(KERNEL_INCLUDE)
+config:
+	@if [ ! -f config.mk -o configure -nt config.mk ]; then \
+		sh configure $(KERNEL_INCLUDE); \
+	fi
 
 install: all
 	install -m 0755 -d $(DESTDIR)$(SBINDIR)

=== dcb/Makefile ===
# SPDX-License-Identifier: GPL-2.0
include ../config.mk

TARGETS :=

ifeq ($(HAVE_MNL),y)

DCBOBJ = dcb.o \
         dcb_app.o \
         dcb_buffer.o \
         dcb_dcbx.o \
         dcb_ets.o \
         dcb_maxrate.o \
         dcb_pfc.o
TARGETS += dcb
LDLIBS += -lm

endif

all: $(TARGETS) $(LIBS)

dcb: $(DCBOBJ) $(LIBNETLINK)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	for i in $(TARGETS); \
	do install -m 0755 $$i $(DESTDIR)$(SBINDIR); \
	done

clean:
	rm -f $(DCBOBJ) $(TARGETS)

=== genl/Makefile ===
# SPDX-License-Identifier: GPL-2.0
GENLOBJ=genl.o

include ../config.mk
SHARED_LIBS ?= y

CFLAGS += -fno-strict-aliasing

GENLMODULES :=
GENLMODULES += ctrl.o

GENLOBJ += $(GENLMODULES)

GENLLIB :=

ifeq ($(SHARED_LIBS),y)
LDFLAGS += -Wl,-export-dynamic
LDLIBS  += -lm -ldl
endif

all: genl

genl: $(GENLOBJ) $(LIBNETLINK) $(LIBUTIL) $(GENLLIB)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	install -m 0755 genl $(DESTDIR)$(SBINDIR)

clean:
	rm -f $(GENLOBJ) $(GENLLIB) genl

ifneq ($(SHARED_LIBS),y)

genl: static-syms.o
static-syms.o: static-syms.h
static-syms.h: $(wildcard *.c)
	files="$^" ; \
	for s in `grep -B 3 '\<dlsym' $$files | sed -n '/snprintf/{s:.*"\([^"]*\)".*:\1:;s:%s::;p}'` ; do \
		sed -n '/'$$s'[^ ]* =/{s:.* \([^ ]*'$$s'[^ ]*\) .*:extern char \1[] __attribute__((weak)); if (!strcmp(sym, "\1")) return \1;:;p}' $$files ; \
	done > $@

endif

=== rdma/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 CFLAGS += -I./include/uapi/
 
 RDMA_OBJ = rdma.o utils.o dev.o link.o res.o res-pd.o res-mr.o res-cq.o \
-	   res-cmid.o res-qp.o sys.o stat.o stat-mr.o
+	   res-cmid.o res-qp.o sys.o stat.o stat-mr.o res-ctx.o res-srq.o
 
 TARGETS += rdma
 endif

=== debian/changelog ===
iproute2 (5.15.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Sun, 14 Nov 2021 12:40:22 +0000

iproute2 (5.15.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.15.0'
  * Drop configure-restore-backward-compatibility.patch, merged upstream
  * Refresh patches to remove fuzz
  * Update Lintian overrides

 -- Luca Boccassi <bluca@debian.org>  Fri, 05 Nov 2021 23:08:14 +0000

iproute2 (5.14.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Wed, 15 Sep 2021 21:11:15 +0100

iproute2 (5.14.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.14.0'
  * Bump Standards-Version to 4.6.0, no changes
  * Backport patch to fix configure breakage

 -- Luca Boccassi <bluca@debian.org>  Thu, 02 Sep 2021 11:44:35 +0100

iproute2 (5.13.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Luca Boccassi <bluca@debian.org>  Sun, 15 Aug 2021 13:07:08 +0100

iproute2 (5.13.0-1) experimental; urgency=medium

  * Update upstream source from tag 'upstream/5.13.0'
    (Closes: #991465)
  * Drop patches merged upstream
  * Install new dcb and vdpa tools

 -- Luca Boccassi <bluca@debian.org>  Mon, 26 Jul 2021 10:56:50 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Homepage: https://wiki.linuxfoundation.org/networking/iproute2
 Vcs-Browser: https://salsa.debian.org/debian/iproute2
 Vcs-Git: https://salsa.debian.org/debian/iproute2.git
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Build-Depends: bison,
                debhelper-compat (= 13),

## iproute2 6.0.0

=== debian/changelog ===
iproute2 (6.0.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/6.0.0'
  * Update Lintian overrides syntax

 -- Luca Boccassi <bluca@debian.org>  Sat, 08 Oct 2022 17:14:47 +0100

iproute2 (5.19.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.19.0'
  * Refresh patch for 5.19
  * Update Lintian overrides for new syntax

 -- Luca Boccassi <bluca@debian.org>  Wed, 03 Aug 2022 13:26:05 +0100

iproute2 (5.18.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.18.0'
  * Bump Standards-Version to 4.6.1, no changes
  * Update Lintian overrides for new version

 -- Luca Boccassi <bluca@debian.org>  Wed, 08 Jun 2022 14:47:01 +0100

iproute2 (5.17.0-2) unstable; urgency=medium

  * d/rules: use execute_after instead of override
  * Switch main branch to debian/sid
  * Remove outdated README.source
  * Move maintainership to Debian Kernel Team
  * Drop unneeded Lintian override
  * Override Lintian warning about missing upstream bug tracking metadata
  * iproute2-doc: install examples

 -- Luca Boccassi <bluca@debian.org>  Mon, 18 Apr 2022 22:10:16 +0200

iproute2 (5.17.0-1) unstable; urgency=medium

  * Fix Lintian warnings regarding d/u/metadata.
  * Update upstream source from tag 'upstream/5.17.0'

 -- Luca Boccassi <bluca@debian.org>  Fri, 25 Mar 2022 10:48:29 +0000

iproute2 (5.16.0-2) unstable; urgency=medium

  * Drop manual /usr/lib/tc/m_ipt.so -> m_xt.so symlink (Closes: #1004059)

 -- Luca Boccassi <bluca@debian.org>  Thu, 20 Jan 2022 10:29:38 +0000

iproute2 (5.16.0-1) unstable; urgency=medium

  * Drop 0004-sync-iptables-header.patch, not necessary anymore
  * Update upstream source from tag 'upstream/5.16.0'
  * Update iproute2.install: routef has been dropped
  * Bump d/copyright year range
  * Update Lintian overrides
  * Suggest python3:any for /usr/bin/routel

 -- Luca Boccassi <bluca@debian.org>  Thu, 13 Jan 2022 22:57:57 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: iproute2
 Section: net
 Priority: optional
-Maintainer: Alexander Wirt <formorer@debian.org>
+Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
 Uploaders: Luca Boccassi <bluca@debian.org>
 Homepage: https://wiki.linuxfoundation.org/networking/iproute2
-Vcs-Browser: https://salsa.debian.org/debian/iproute2
-Vcs-Git: https://salsa.debian.org/debian/iproute2.git
-Standards-Version: 4.6.0
+Vcs-Browser: https://salsa.debian.org/kernel-team/iproute2
+Vcs-Git: https://salsa.debian.org/kernel-team/iproute2.git
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends: bison,
                debhelper-compat (= 13),
@@ -33,7 +33,7 @@
 Replaces: iproute
 Depends: ${misc:Depends}, ${shlibs:Depends}, libcap2-bin,
 Recommends: ${ipmods:Recommends}
-Suggests: iproute2-doc
+Suggests: iproute2-doc, python3:any
 Multi-Arch: foreign
 Description: networking and traffic control tools
  The iproute2 suite is a collection of utilities for networking and

## iproute2 6.1.0

=== dcb/Makefile ===
--- 
+++ 
@@ -1,9 +1,5 @@
 # SPDX-License-Identifier: GPL-2.0
 include ../config.mk
-
-TARGETS :=
-
-ifeq ($(HAVE_MNL),y)
 
 DCBOBJ = dcb.o \
          dcb_app.o \
@@ -14,8 +10,6 @@
          dcb_pfc.o
 TARGETS += dcb
 LDLIBS += -lm
-
-endif
 
 all: $(TARGETS) $(LIBS)

=== devlink/Makefile ===
# SPDX-License-Identifier: GPL-2.0
include ../config.mk

DEVLINKOBJ = devlink.o mnlg.o
TARGETS += devlink
LDLIBS += -lm

all: $(TARGETS) $(LIBS)

devlink: $(DEVLINKOBJ) $(LIBNETLINK)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	for i in $(TARGETS); \
	do install -m 0755 $$i $(DESTDIR)$(SBINDIR); \
	done

clean:
	rm -f $(DEVLINKOBJ) $(TARGETS)

=== testsuite/Makefile ===
# SPDX-License-Identifier: GPL-2.0
## -- Config --
DEV := lo
PREFIX := sudo -E unshare -n
RESULTS_DIR := results
## -- End Config --

HAVE_UNSHARED_UTIL := $(shell unshare --version 2> /dev/null)

rwildcard=$(wildcard $1$2) $(foreach d,$(wildcard $1*),$(call rwildcard,$d/,$2))

TESTS := $(patsubst tests/%,%,$(call rwildcard,tests/,*.t))
TESTS_DIR := $(dir $(TESTS))

IPVERS := $(filter-out iproute2/Makefile,$(wildcard iproute2/*))

KENVFN := $(shell mktemp /tmp/tc_testkenv.XXXXXX)
ifneq (,$(wildcard /proc/config.gz))
	KCPATH := /proc/config.gz
else
	KVER := $(shell uname -r)
	KCPATHS := /lib/modules/$(KVER)/config /boot/config-$(KVER)
	KCPATH := $(firstword $(wildcard $(KCPATHS)))
endif

.PHONY: compile listtests alltests configure $(TESTS)

configure:
	$(MAKE) -C iproute2 configure

compile: configure generate_nlmsg
	$(MAKE) -C iproute2

listtests:
	@for t in $(TESTS); do \
		echo "$$t"; \
	done

generate_nlmsg:
	$(MAKE) -C tools

alltests: generate_nlmsg $(TESTS)

testclean:
	@echo "Removing $(RESULTS_DIR) dir ..."
	@rm -rf $(RESULTS_DIR)

clean: testclean
	@rm -f iproute2/iproute2-this
	@rm -f tests/ip/link/dev_wo_vf_rate.nl
	$(MAKE) -C tools clean

distclean: clean
	$(MAKE) -C iproute2 distclean

$(TESTS): generate_nlmsg testclean
ifeq (,$(IPVERS))
	$(error Please run make first)
endif
ifeq (,$(HAVE_UNSHARED_UTIL))
	$(error Please install util-linux tools to run tests in separated network namespace)
endif
	@./tools/generate_nlmsg

	@mkdir -p $(RESULTS_DIR)

	@for d in $(TESTS_DIR); do \
	    mkdir -p $(RESULTS_DIR)/$$d; \
	done

	@if [ "$(KCPATH)" = "/proc/config.gz" ]; then \
		gunzip -c $(KCPATH) >$(KENVFN); \
	elif [ "$(KCPATH)" != "" ]; then \
               cat $(KCPATH) >$(KENVFN); \
	fi
	@sed -i -e 's/^CONFIG_/export CONFIG_/' $(KENVFN)

	@for i in $(IPVERS); do \
		o=`echo $$i | sed -e 's/iproute2\///'`; \
		echo -n "Running $@ [$$o/`uname -r`]: "; \
		TMP_ERR=`mktemp /tmp/tc_testsuite.XXXXXX`; \
		TMP_OUT=`mktemp /tmp/tc_testsuite.XXXXXX`; \
		. $(KENVFN); \
		STD_ERR="$$TMP_ERR" STD_OUT="$$TMP_OUT" \
		TC="$$i/tc/tc" IP="$$i/ip/ip" SS=$$i/misc/ss BRIDGE="$$i/bridge/bridge" \
		DEV="$(DEV)" IPVER="$@" SNAME="$$i" \
		ERRF="$(RESULTS_DIR)/$@.$$o.err" $(PREFIX) tests/$@ > $(RESULTS_DIR)/$@.$$o.out; \
		if [ "$$?" = "127" ]; then \
			printf "\033[1;35mSKIPPED\033[0m\n"; \
		elif [ -e "$(RESULTS_DIR)/$@.$$o.err" ]; then \
			printf "\033[0;31mFAILED\033[0m\n"; \
		else \
			printf "\033[0;32mPASS\033[0m\n"; \
		fi; \
		rm "$$TMP_ERR" "$$TMP_OUT"; \
		sudo dmesg > $(RESULTS_DIR)/$@.$$o.dmesg; \
	done

=== testsuite/tools/Makefile ===
# SPDX-License-Identifier: GPL-2.0
CFLAGS=
include ../../config.mk

generate_nlmsg: generate_nlmsg.c ../../lib/libnetlink.a ../../lib/libutil.a
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) -I../../include -I../../include/uapi -include../../include/uapi/linux/netlink.h -o $@ $^ -lmnl -lcap

clean:
	rm -f generate_nlmsg

=== debian/changelog ===
iproute2 (6.1.0-3~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Thu, 25 May 2023 18:52:09 +0100

iproute2 (6.1.0-3) unstable; urgency=medium

  * Ensure 'ip mo' resolves to 'ip monitor' (Closes: #1036534)

 -- Luca Boccassi <bluca@debian.org>  Mon, 22 May 2023 14:19:52 +0100

iproute2 (6.1.0-2) unstable; urgency=medium

  * Add Romanian language translation for debconf (Closes: #1031917)
  * Bump Standards-Version to 4.6.2, no changes
  * Bump d/copyright year range

 -- Luca Boccassi <bluca@debian.org>  Sat, 25 Feb 2023 19:46:35 +0000

iproute2 (6.1.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Mon, 26 Dec 2022 21:19:59 +0100

iproute2 (6.1.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/6.1.0'
  * Update Lintian overrides syntax

 -- Luca Boccassi <bluca@debian.org>  Fri, 16 Dec 2022 15:17:20 +0000

iproute2 (6.0.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Fri, 14 Oct 2022 11:30:43 +0100

iproute2 (5.19.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Mon, 08 Aug 2022 11:32:28 +0100

iproute2 (5.18.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Tue, 14 Jun 2022 11:07:05 +0100

iproute2 (5.17.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Thu, 31 Mar 2022 22:35:36 +0100

iproute2 (5.16.0-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Luca Boccassi <bluca@debian.org>  Tue, 25 Jan 2022 22:35:36 +0000

=== debian/tests/control ===
# the tests depend on the kernel and might break the env
# therefore do not run as build time tests
Tests: testsuite.sh
Restrictions: allow-stderr, isolation-machine, needs-root, rw-build-tree
Depends: build-essential, locales-all, dpkg-dev, sudo:native, kmod, @builddeps@

## iproute2 6.4.0

=== debian/changelog ===
iproute2 (6.4.0-1) unstable; urgency=medium

  * Fix patch header Forwarded field
  * Enable ELF metadata stamping
  * Update upstream source from tag 'upstream/6.4.0'
  * Update Lintian overrides

 -- Luca Boccassi <bluca@debian.org>  Fri, 30 Jun 2023 12:16:40 +0100

iproute2 (6.3.0-1) unstable; urgency=medium

  * Drop obsolete conflicts/replaces
  * Update upstream source from tag 'upstream/6.3.0'

 -- Luca Boccassi <bluca@debian.org>  Tue, 13 Jun 2023 23:49:37 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 # for DEB_* variables
 include /usr/share/dpkg/default.mk
+include /usr/share/debhelper/dh_package_notes/package-notes.mk
 
 ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
 	export CC=$(DEB_HOST_GNU_TYPE)-gcc
@@ -28,13 +29,12 @@
 %:
 	dh $@
 
-override_dh_clean:
-	dh_clean
+execute_after_dh_clean:
 	make distclean
 
 override_dh_shlibdeps:
 	dh_shlibdeps -a -Xq_atm.so -Xm_xt.so -Xm_ipt.so
-	dh_shlibdeps -a -- -pipmods -dRecommends -e debian/iproute2/usr/lib/tc/m_xt.so -e debian/iproute2/usr/lib/tc/q_atm.so -xlibc6
+	dh_shlibdeps -a -- -pipmods -dRecommends -e debian/iproute2/usr/lib/$(DEB_HOST_MULTIARCH)/tc/m_xt.so -e debian/iproute2/usr/lib/$(DEB_HOST_MULTIARCH)/tc/q_atm.so -xlibc6
 
 override_dh_auto_test:
 	# upstream test suite needs root and leaves machine unclean, skip it
